import React, { useState, useEffect } from 'react';
import { Text, StyleSheet } from 'react-native';
import Icon from 'react-native-vector-icons/MaterialIcons';
import API from './../API.js';
import { useNavigation } from '@react-navigation/native';
import AsyncStorage from '@react-native-async-storage/async-storage';
import { IconButton } from 'react-native-paper';

const storeName = async (key, value) => {
    try {
        const jsonValue = JSON.stringify(value)
        await AsyncStorage.setItem('Name_' + key, jsonValue)
    } catch (e) {
    }
}

const getName = async (key) => {
    try {
        const value = await AsyncStorage.getItem('Name_' + key)
        if (value !== null) {
            return JSON.parse(value);
        }
    } catch (e) {
        return []
    }
}

let UserName = ({ profileid, hideIcon }) => {
    let [profile, setProfile] = useState({});
    const navigation = useNavigation();

    useEffect(() => {
        let subscribed = true;
        let getData = async () => {
            let cacheProfile = await getName(profileid);
            if (cacheProfile && cacheProfile.profile && subscribed) setProfile(cacheProfile);
            let p = await API.getUserProfile(profileid).catch(() => { return {} });
            if (subscribed)
                setProfile(p);
            storeName(profileid, p);
            //console.log("Fetching Name:" + p?.profile?.firstName);
        }
        getData();
        return () => {
            subscribed = false;
        };
    }, [profileid]);

    let icon = profile._id ? (!profile.isGroup ? "person-outline" : "group") : '';
    icon = icon === "person-outline" && profile.subscription && profile.subscription > (new Date() - 0) ? "assignment-ind" : icon;
    icon = icon === "group" && profile.isCourse ? "subscriptions" : icon;
    icon = icon === "group" && profile.isPrivate ? "screen-lock-portrait" : icon;
    const fullName = " " + profile.profile?.firstName + " " + profile.profile?.lastName;

    const onPress = () => {
        return navigation.navigate('Profile', { profileid })
    }

    return (
        <Text onPress={onPress}>
            {!hideIcon ? 
                <Icon name={icon} style={{fontSize:13, marginRight: 10}} /> : <></>}
            {fullName}
        </Text>
    );
}

export default React.memo(UserName);

const styles = StyleSheet.create({
});
